﻿@using Xtoman.Domain.WebServices.TradingPlatform.Kraken
@model KrakenAddOrderViewModel
@{
    ViewBag.Title = "Trade on Kraken";
}

@if (Model.AssetPairs.ResultType == KrakenGeneralResultType.success && Model.AssetPairs.Result.Count > 0)
{
    var groups = Model.AssetPairs.Result.Values.DistinctBy(p => p.Quote).Select(p => p.Quote).ToList();
    using (Html.BeginForm("Trade", "Kraken", FormMethod.Post, new { @class = "form-horizontal", role = "form", id = "tradeForm" }))
    {
        <div class="form-group row">
            <div class="col-md-4">
                <label for="Pair">جفت ارز</label>
                <select id="Pair" name="Pair" class="form-control">
                    @foreach (var groupName in groups)
                    {
                        <optgroup label="@groupName">@groupName</optgroup>
                        var groupedItems = Model.AssetPairs.Result.Values.Where(p => p.Quote == groupName).ToList();
                        foreach (var item in groupedItems)
                        {
                            <option value="@item.Base@item.Quote">@item.AltName</option>
                        }
                    }
                </select>
            </div>
            <div class="col-md-4">
                <label for="OrderType">نوع سفارش</label>
                @Html.EnumDropDownListFor(m => m.OrderType, new { @class = "form-control" })
            </div>
            <div class="col-md-4">
                <label for="OrderSide">جهت سفارش</label>
                @Html.EnumDropDownListFor(m => m.OrderSide, new { @class = "form-control" })
            </div>
        </div>
        <div class="form-group row">
            <div class="col-md-4">
                <label for="Volume">مقدار</label>
                @Html.TextBoxFor(m => m.Volume, new { @class = "form-control", type = "number", step = "0.01", min = "0.001" })
            </div>
            <div class="col-md-4" style="display:none;">
                <label id="PriceLabel" for="Price">قیمت</label>
                @Html.TextBoxFor(m => m.Price, new { @class = "form-control", type = "number", step = "0.01", min = "0.001" })
            </div>
            <div class="col-md-4" style="display:none;">
                <label id="Price2Label" for="Price2">قیمت 2</label>
                @Html.TextBoxFor(m => m.Price2, new { @class = "form-control", type = "number", step = "0.01", min = "0.001" })
            </div>
        </div>
        <div class="form-group row">
            <div class="col-12">
                <h4 class="header-title">تنظیمات سفارش</h4>
                <div class="mt-3">
                    @foreach (KrakenOrderFlag orderFlag in Enum.GetValues(typeof(KrakenOrderFlag)))
                    {
                        @Html.HiddenFor(m => m.OrderFlags[orderFlag.ToInt()].OrderFlag)
                        <div class="checkbox checkbox-primary">
                            <input id="OrderFlags_@orderFlag.ToInt()__IsSelected" name="OrderFlags[@orderFlag.ToInt()].IsSelected" type="checkbox">
                            <label for="OrderFlags_@orderFlag.ToInt()__IsSelected">
                                @orderFlag.ToDisplay(DisplayProperty.Description)
                            </label>
                        </div>
                    }
                </div>
            </div>
        </div>
        <button type="submit" class="btn btn-primary">انجام سفارش</button>
    }
}

@section Scripts {
    @Scripts.Render("~/js/jqueryval")
    <script>
        $('#OrderType option:nth-child(3), #OrderType option:nth-child(4), #OrderType option:nth-child(5), #OrderType option:nth-child(6), #OrderType option:nth-child(7), #OrderType option:nth-child(8), #OrderType option:nth-child(9), #OrderType option:nth-child(10), #OrderType option:nth-child(11), #OrderType option:nth-child(12)').attr('disabled', 'disabled');
        $('select').select2();

        $(document).ready(function () {
            initializeOrderType();
        });

        $('#OrderType').on('change', initializeOrderType);

        function initializeOrderType() {
            var value = parseInt($('#OrderType').val());
            $('#OrderFlags_@KrakenOrderFlag.PostOnlyOrder.ToInt()__IsSelected').prop('checked', false).parent().removeClass('active');
            $('#OrderFlags_@KrakenOrderFlag.PostOnlyOrder.ToInt()__IsSelected').attr('disabled','disabled');
            switch (value) {
                case @KrakenOrderType.Limit.ToInt():
                    $('#Price').val('').parent().show();
                    $('#PriceLabel').text('قیمت');
                    $('#OrderFlags_@KrakenOrderFlag.PostOnlyOrder.ToInt()__IsSelected').removeAttr('disabled');
                    break;
                case @KrakenOrderType.Market.ToInt():
                    $('#Price').val('').parent().hide();
                    $('#Price2').val('').parent().hide();
                    $('#OrderFlags_@KrakenOrderFlag.PreferFeeInQuoteCurrency.ToInt()__IsSelected').prop('checked', true).parent().addClass('active');
                    break;
            }
        }

        $('#tradeForm').submit(function (e) {
            $('button[type="submit"]').addClass('disabled');
            e.preventDefault();
            var $tradeForm = $(this);
            confirmDialog("آیا از انجام این ترید مطمئن هستید؟", function () {
                $tradeForm.unbind('submit').submit();
            });
        });
    </script>
}
